import React, { HTMLAttributes } from 'react';
export declare type PasswordRequirementsProps = HTMLAttributes<HTMLDivElement> & {
    passwordText: string;
};
/**
 * Component that renders all of the password requirement line items with check indicators.
 *
 * @param passwordText The string to conduct the complexity checks against
 *
 * @category Component
 */
export declare const PasswordRequirements: React.FC<React.PropsWithChildren<React.PropsWithChildren<PasswordRequirementsProps>>>;
