"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Login = void 0;
var react_1 = __importStar(require("react"));
var RoutingContext_1 = require("../contexts/RoutingContext");
var react_auth_shared_1 = require("@brightlayer-ui/react-auth-shared");
var react_router_dom_1 = require("react-router-dom");
var Button_1 = __importDefault(require("@mui/material/Button"));
var Typography_1 = __importDefault(require("@mui/material/Typography"));
var TextField_1 = __importDefault(require("@mui/material/TextField"));
var Grid_1 = __importDefault(require("@mui/material/Grid"));
var FormControlLabel_1 = __importDefault(require("@mui/material/FormControlLabel"));
var Checkbox_1 = __importDefault(require("@mui/material/Checkbox"));
var styles_1 = require("@mui/material/styles");
var createStyles_1 = __importDefault(require("@mui/styles/createStyles"));
var makeStyles_1 = __importDefault(require("@mui/styles/makeStyles"));
var components_1 = require("../components");
var Close_1 = __importDefault(require("@mui/icons-material/Close"));
var eaton_stacked_logo_png_1 = __importDefault(require("../assets/images/eaton_stacked_logo.png"));
var cybersecurity_certified_png_1 = __importDefault(require("../assets/images/cybersecurity_certified.png"));
var Colors = __importStar(require("@brightlayer-ui/colors"));
var clsx_1 = __importDefault(require("clsx"));
var HELPER_TEXT_HEIGHT = 22;
var useStyles = (0, makeStyles_1.default)(function (theme) {
    var _a, _b, _c, _d;
    return (0, createStyles_1.default)({
        emailFormField: (_a = {
                marginBottom: "".concat((parseInt(theme.spacing(4)) + HELPER_TEXT_HEIGHT).toString(), "px"),
                '&$hasError': {
                    marginBottom: theme.spacing(4),
                }
            },
            _a[theme.breakpoints.down('sm')] = {
                marginBottom: "".concat((parseInt(theme.spacing(3)) + HELPER_TEXT_HEIGHT).toString(), "px"),
                '&$hasError': {
                    marginBottom: theme.spacing(3),
                },
            },
            _a),
        passwordFormField: {
            marginBottom: "".concat((parseInt(theme.spacing(3)) + HELPER_TEXT_HEIGHT).toString(), "px"),
            // marginBottom: theme.spacing(3) + HELPER_TEXT_HEIGHT,
            '&$hasError': {
                marginBottom: theme.spacing(3),
            },
        },
        buttonRow: (_b = {
                marginBottom: theme.spacing(5),
                flexWrap: 'nowrap'
            },
            _b[theme.breakpoints.down('sm')] = {
                flexWrap: 'wrap',
                flexDirection: 'column',
                justifyContent: 'center',
            },
            _b),
        errorMessageBox: {
            width: '100%',
            backgroundColor: function (loginErrorDisplayConfig) {
                return loginErrorDisplayConfig.backgroundColor || theme.palette.error.main;
            },
            borderRadius: 4,
            padding: 16,
            color: function (loginErrorDisplayConfig) {
                return loginErrorDisplayConfig.fontColor || Colors.white[50];
            },
            marginBottom: 16,
            marginTop: function (loginErrorDisplayConfig) {
                return loginErrorDisplayConfig.position !== 'bottom' ? 0 : theme.spacing(-1);
            },
        },
        errorBoxDismissIcon: {
            '&:hover': {
                cursor: 'pointer',
            },
            float: 'right',
        },
        cyberBadge: {
            alignSelf: 'center',
            maxWidth: '30%',
        },
        debugButton: {
            position: 'absolute',
            top: theme.spacing(3),
            right: theme.spacing(3),
        },
        debugMessage: {
            backgroundColor: Colors.yellow[500],
            padding: theme.spacing(1),
            marginBottom: theme.spacing(2),
        },
        formContent: (_c = {
                padding: "".concat(theme.spacing(4), " ").concat(theme.spacing(8)),
                display: 'flex',
                flexDirection: 'column'
            },
            _c[theme.breakpoints.down('sm')] = {
                padding: "".concat(theme.spacing(4), " ").concat(theme.spacing(4)),
            },
            _c),
        link: {
            fontWeight: 600,
            textTransform: 'none',
            textDecoration: 'none',
            color: theme.palette.primary.main,
            '&:visited': {
                color: 'inherit',
            },
        },
        linksWrapper: {
            textAlign: 'center',
            paddingBottom: theme.spacing(4),
        },
        largeIcon: {
            width: 60,
            height: 60,
            color: theme.palette.text.secondary,
        },
        rememberMeCheckbox: (_d = {},
            _d[theme.breakpoints.down('sm')] = {
                marginRight: 0,
            },
            _d),
        hasError: {},
        productLogo: {
            maxWidth: '100%',
            maxHeight: 80,
        },
    });
});
/**
 * Login screen with loading and error states, as well as "remember me" functionality to store a user's email between logins.
 * Requires being wrapped in an [[AuthNavigationContainer]] for access to global state and actions for authentication and registration.
 * Has a debug mode which shows buttons that allow direct access to the deep link flows (invite registration, set password from forgot password, etc.).
 *
 *
 * @category Component
 */
var Login = function () {
    var _a, _b;
    var _c, _d, _e;
    var securityState = (0, react_auth_shared_1.useSecurityState)();
    var t = (0, react_auth_shared_1.useLanguageLocale)().t;
    var authUIActions = (0, react_auth_shared_1.useAccountUIActions)();
    var authUIState = (0, react_auth_shared_1.useAccountUIState)();
    var routes = (0, RoutingContext_1.useRoutes)().routes;
    var theme = (0, styles_1.useTheme)();
    var _f = (0, react_auth_shared_1.useInjectedUIContext)(), _g = _f.loginErrorDisplayConfig, loginErrorDisplayConfig = _g === void 0 ? { mode: 'dialog' } : _g, otherUIContext = __rest(_f, ["loginErrorDisplayConfig"]);
    var classes = useStyles(loginErrorDisplayConfig);
    var _h = otherUIContext.showRememberMe, showRememberMe = _h === void 0 ? true : _h, _j = otherUIContext.allowDebugMode, allowDebugMode = _j === void 0 ? false : _j, _k = otherUIContext.showSelfRegistration, showSelfRegistration = _k === void 0 ? true : _k, _l = otherUIContext.enableResetPassword, enableResetPassword = _l === void 0 ? true : _l, _m = otherUIContext.showContactSupport, showContactSupport = _m === void 0 ? true : _m, _o = otherUIContext.showCybersecurityBadge, showCybersecurityBadge = _o === void 0 ? true : _o, projectImage = otherUIContext.projectImage, loginFooter = otherUIContext.loginFooter, _p = otherUIContext.loginHeader, loginHeader = _p === void 0 ? (react_1.default.createElement("div", { style: { marginBottom: theme.spacing(6) } },
        react_1.default.createElement("img", { className: classes.productLogo, src: projectImage || eaton_stacked_logo_png_1.default, alt: "logo" }))) : _p, _q = otherUIContext.loginType, loginType = _q === void 0 ? 'email' : _q, loginActions = otherUIContext.loginActions;
    var passwordField = (0, react_1.useRef)(null);
    // Local State
    var _r = react_1.default.useState(showRememberMe ? (_c = securityState.rememberMeDetails.rememberMe) !== null && _c !== void 0 ? _c : false : false), rememberPassword = _r[0], setRememberPassword = _r[1];
    var _s = react_1.default.useState(showRememberMe ? (_d = securityState.rememberMeDetails.email) !== null && _d !== void 0 ? _d : '' : ''), emailInput = _s[0], setEmailInput = _s[1];
    var _t = react_1.default.useState(''), passwordInput = _t[0], setPasswordInput = _t[1];
    var _u = react_1.default.useState(false), hasAcknowledgedError = _u[0], setHasAcknowledgedError = _u[1];
    var _v = react_1.default.useState(false), debugMode = _v[0], setDebugMode = _v[1];
    var _w = react_1.default.useState(false), showErrorMessageBox = _w[0], setShowErrorMessageBox = _w[1];
    var loginTapped = (0, react_1.useCallback)(function () {
        setHasAcknowledgedError(false);
        void authUIActions.actions.logIn(emailInput, passwordInput, showRememberMe ? rememberPassword : false);
    }, [setHasAcknowledgedError, authUIActions, emailInput, passwordInput, rememberPassword, showRememberMe]);
    var transitState = authUIState.login;
    var showLinks = showSelfRegistration || enableResetPassword || showContactSupport;
    var hasTransitError = authUIState.login.transitErrorMessage !== null;
    var transitErrorMessage = (_e = authUIState.login.transitErrorMessage) !== null && _e !== void 0 ? _e : t('blui:MESSAGES.REQUEST_ERROR');
    var isInvalidCredentials = transitErrorMessage.replace('blui:', '') === 'LOGIN.INCORRECT_CREDENTIALS' ||
        transitErrorMessage.replace('blui:', '') === 'LOGIN.INVALID_CREDENTIALS';
    var _x = react_1.default.useState(false), isValidEmail = _x[0], setIsValidEmail = _x[1];
    var _y = react_1.default.useState(false), shouldValidateEmail = _y[0], setShouldValidateEmail = _y[1];
    (0, react_1.useEffect)(function () {
        authUIActions.dispatch(react_auth_shared_1.AccountActions.resetLogin());
    }, [] // eslint-disable-line react-hooks/exhaustive-deps
    );
    (0, react_1.useEffect)(function () {
        if (hasTransitError) {
            setShowErrorMessageBox(true);
        }
    }, [hasTransitError]);
    var hasEmailError = (0, react_1.useCallback)(function () { return loginType === 'email' && shouldValidateEmail && emailInput.length !== 0 && !isValidEmail; }, [shouldValidateEmail, emailInput, isValidEmail, loginType]);
    // Construct the dynamic elements
    var errorDialog = (react_1.default.createElement(components_1.SimpleDialog, { title: t('blui:MESSAGES.ERROR'), body: t(transitErrorMessage), open: hasTransitError && !hasAcknowledgedError, onClose: function () {
            setHasAcknowledgedError(true);
        } }));
    var errorMessageBox = !isInvalidCredentials && hasTransitError && transitErrorMessage && showErrorMessageBox ? (react_1.default.createElement("div", { className: classes.errorMessageBox },
        loginErrorDisplayConfig.dismissible !== false && (react_1.default.createElement(Close_1.default, { className: classes.errorBoxDismissIcon, onClick: function () {
                setShowErrorMessageBox(false);
            } })),
        react_1.default.createElement(Typography_1.default, { variant: "body2" }, t(transitErrorMessage)))) : (react_1.default.createElement(react_1.default.Fragment, null));
    var contactEatonRepresentative = showContactSupport ? (react_1.default.createElement(Typography_1.default, { variant: "body2", color: 'primary' },
        react_1.default.createElement(react_router_dom_1.Link, { className: classes.link, to: routes.SUPPORT }, t('blui:MESSAGES.CONTACT')))) : (react_1.default.createElement(react_1.default.Fragment, null));
    var getEmailHelperText = function () {
        if (hasEmailError()) {
            return t('blui:MESSAGES.EMAIL_ENTRY_ERROR');
        }
        else if (isInvalidCredentials) {
            return t('blui:LOGIN.INCORRECT_CREDENTIALS');
        }
        return '';
    };
    var createAccountOption = react_1.default.createElement(react_1.default.Fragment, null);
    if (showSelfRegistration) {
        createAccountOption = (react_1.default.createElement(Typography_1.default, { variant: "body2", color: 'primary', style: { marginBottom: theme.spacing(4) } },
            react_1.default.createElement(react_router_dom_1.Link, { className: classes.link, to: routes.REGISTER_SELF }, t('blui:ACTIONS.CREATE_ACCOUNT'))));
    }
    // Create buttons and links for debug mode
    var debugButton = react_1.default.createElement(react_1.default.Fragment, null);
    if (allowDebugMode) {
        debugButton = (react_1.default.createElement(Button_1.default, { variant: 'contained', color: 'primary', onClick: function () { return setDebugMode(!debugMode); }, className: classes.debugButton }, "DEBUG"));
    }
    var debugMessage = react_1.default.createElement(react_1.default.Fragment, null);
    if (debugMode) {
        debugMessage = (react_1.default.createElement("div", { className: classes.debugMessage },
            react_1.default.createElement(Typography_1.default, { variant: 'h6', align: 'center' }, "DEBUG MODE")));
    }
    var debugLinks = !debugMode ? null : (react_1.default.createElement("div", { className: classes.linksWrapper },
        react_1.default.createElement(Typography_1.default, { variant: "body2" },
            react_1.default.createElement(react_router_dom_1.Link, { className: classes.link, to: "".concat(routes.REGISTER_INVITE, "?code=DEBUG_VALIDATION_CODE_DEADBEEF") }, "[Test Invite Register]")),
        react_1.default.createElement(Typography_1.default, { variant: "body2" },
            react_1.default.createElement(react_router_dom_1.Link, { className: classes.link, to: routes.REGISTER_SELF }, "[Test Self Register]")),
        react_1.default.createElement(Typography_1.default, { variant: "body2" },
            react_1.default.createElement(react_router_dom_1.Link, { className: classes.link, to: "".concat(routes.FORGOT_PASSWORD) }, "[Test Forgot Password]")),
        react_1.default.createElement(Typography_1.default, { variant: "body2" },
            react_1.default.createElement(react_router_dom_1.Link, { className: classes.link, to: "".concat(routes.RESET_PASSWORD, "?code=DEBUG_VALIDATION_CODE_DEADBEEF") }, "[Test Reset Password Email]")),
        react_1.default.createElement(Typography_1.default, { variant: "body2" },
            react_1.default.createElement(react_router_dom_1.Link, { className: classes.link, to: "".concat(routes.SUPPORT) }, "[Test Contact Support]"))));
    return (react_1.default.createElement(components_1.BrandedCardContainer, { loading: transitState.transitInProgress },
        !isInvalidCredentials &&
            (loginErrorDisplayConfig.mode === 'dialog' || loginErrorDisplayConfig.mode === 'both') &&
            transitErrorMessage &&
            errorDialog,
        debugButton,
        react_1.default.createElement("form", { onSubmit: function (evt) {
                evt.preventDefault();
                loginTapped();
            } },
            react_1.default.createElement("div", { className: classes.formContent },
                loginHeader && typeof loginHeader === 'function' && loginHeader(null),
                loginHeader && typeof loginHeader !== 'function' && loginHeader,
                debugMessage,
                debugLinks,
                (loginErrorDisplayConfig.mode === 'message-box' || loginErrorDisplayConfig.mode === 'both') &&
                    loginErrorDisplayConfig.position !== 'bottom' &&
                    errorMessageBox,
                react_1.default.createElement(TextField_1.default, { label: loginType === 'username' ? t('blui:LABELS.USERNAME') : t('blui:LABELS.EMAIL'), id: "email", name: loginType === 'username' ? 'username' : 'email', type: loginType === 'username' ? 'text' : 'email', className: (0, clsx_1.default)(classes.emailFormField, (_a = {},
                        _a[classes.hasError] = isInvalidCredentials || hasEmailError(),
                        _a)), value: emailInput, onChange: function (evt) {
                        var value = evt.target.value;
                        setIsValidEmail(react_auth_shared_1.EMAIL_REGEX.test(value));
                        setEmailInput(value);
                        if (authUIState.login.transitErrorMessage !== null)
                            authUIActions.dispatch(react_auth_shared_1.AccountActions.resetLogin());
                    }, onKeyPress: function (e) {
                        if (e.key === 'Enter' && passwordField.current)
                            passwordField.current.focus();
                    }, onBlur: function () {
                        setShouldValidateEmail(true);
                    }, variant: "filled", error: hasEmailError() || isInvalidCredentials, helperText: getEmailHelperText() }),
                react_1.default.createElement(components_1.SecureTextField, { inputRef: passwordField, id: "password", name: "password", label: t('blui:LABELS.PASSWORD'), className: (0, clsx_1.default)(classes.passwordFormField, (_b = {}, _b[classes.hasError] = isInvalidCredentials, _b)), value: passwordInput, onChange: function (evt) {
                        setPasswordInput(evt.target.value);
                        if (authUIState.login.transitErrorMessage !== null)
                            authUIActions.dispatch(react_auth_shared_1.AccountActions.resetLogin());
                    }, variant: "filled", error: isInvalidCredentials, helperText: isInvalidCredentials ? t('blui:LOGIN.INCORRECT_CREDENTIALS') : '' }),
                (loginErrorDisplayConfig.mode === 'message-box' || loginErrorDisplayConfig.mode === 'both') &&
                    loginErrorDisplayConfig.position === 'bottom' &&
                    errorMessageBox,
                react_1.default.createElement(Grid_1.default, { container: true, direction: "row", alignItems: "center", justifyContent: "space-between", className: classes.buttonRow },
                    showRememberMe && (react_1.default.createElement(FormControlLabel_1.default, { className: classes.rememberMeCheckbox, control: react_1.default.createElement(Checkbox_1.default, { color: "primary", checked: rememberPassword, onChange: function (evt) { return setRememberPassword(evt.target.checked); } }), label: t('blui:ACTIONS.REMEMBER') })),
                    react_1.default.createElement(Button_1.default, { type: "submit", variant: "contained", disableElevation: true, disabled: loginType === 'username'
                            ? !emailInput || !passwordInput
                            : !react_auth_shared_1.EMAIL_REGEX.test(emailInput) || !passwordInput, color: "primary", style: { width: showRememberMe ? 150 : '100%' } }, t('blui:ACTIONS.LOG_IN'))),
                loginActions && typeof loginActions === 'function' && loginActions(null),
                loginActions && typeof loginActions !== 'function' && loginActions,
                react_1.default.createElement("div", { className: showLinks ? classes.linksWrapper : undefined },
                    enableResetPassword && (react_1.default.createElement(Typography_1.default, { variant: "body2", color: 'primary' },
                        react_1.default.createElement(react_router_dom_1.Link, { className: classes.link, to: routes.FORGOT_PASSWORD }, t('blui:LABELS.FORGOT_PASSWORD')))),
                    (showContactSupport || showSelfRegistration) && (react_1.default.createElement(Typography_1.default, { variant: "body2", style: { marginTop: enableResetPassword ? theme.spacing(4) : 0 } }, t('blui:LABELS.NEED_ACCOUNT'))),
                    createAccountOption,
                    contactEatonRepresentative),
                loginFooter && typeof loginFooter === 'function' && loginFooter(null),
                loginFooter && typeof loginFooter !== 'function' && loginFooter,
                showCybersecurityBadge && (react_1.default.createElement("img", { src: cybersecurity_certified_png_1.default, className: classes.cyberBadge, alt: "CyberSecurity Certification Badge" }))))));
};
exports.Login = Login;
