"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sharedDialogStyles = void 0;
var createStyles_1 = __importDefault(require("@mui/styles/createStyles"));
var sharedDialogStyles = function (theme) {
    var _a, _b, _c, _d, _e;
    return (0, createStyles_1.default)({
        dialogTitle: (_a = {
                padding: "".concat(theme.spacing(4), " ").concat(theme.spacing(3), " 0 ").concat(theme.spacing(3))
            },
            _a[theme.breakpoints.down('sm')] = {
                padding: "".concat(theme.spacing(2), " ").concat(theme.spacing(2), " 0 ").concat(theme.spacing(2)),
            },
            _a),
        dialogContent: (_b = {
                flex: '1 1 0px',
                overflow: 'auto',
                display: 'flex',
                flexDirection: 'column',
                padding: "".concat(theme.spacing(2), " ").concat(theme.spacing(3))
            },
            _b[theme.breakpoints.down('sm')] = {
                padding: "".concat(theme.spacing(2), " ").concat(theme.spacing(2), " ").concat(theme.spacing(3), " ").concat(theme.spacing(2)),
            },
            _b),
        dialogActions: (_c = {
                padding: theme.spacing(3),
                justifyContent: 'flex-end'
            },
            _c[theme.breakpoints.down('sm')] = {
                padding: theme.spacing(2),
            },
            _c),
        dialogButton: {
            width: 100,
            '&$fullWidth': {
                width: '100%',
            },
        },
        fullDivider: (_d = {
                margin: "".concat(theme.spacing(5), " -").concat(theme.spacing(3), " ").concat(theme.spacing(4))
            },
            _d[theme.breakpoints.down('sm')] = {
                margin: "".concat(theme.spacing(5), " -").concat(theme.spacing(2), " ").concat(theme.spacing(4)),
            },
            _d),
        stepper: {
            background: 'transparent',
            width: '100%',
            padding: 0,
        },
        stepperDot: {
            margin: "0px ".concat(theme.spacing(0.5)),
        },
        textField: (_e = {
                marginTop: theme.spacing(4)
            },
            _e[theme.breakpoints.down('sm')] = {
                marginTop: theme.spacing(3),
            },
            _e),
        fullWidth: {},
    });
};
exports.sharedDialogStyles = sharedDialogStyles;
